Logo AND Algorithmique Numérique Distribuée

Public GIT Repository
Cosmetics: hostfile and machinefile are synonyms.
[simgrid.git] / src / smpi / smpirun.in
1 #! /bin/sh
2
3 # Copyright (c) 2007-2016, The SimGrid Team. All rights reserved.
4
5 # This program is free software; you can redistribute it and/or modify it
6 # under the terms of the license (GNU LGPL) which comes with this package.
7
8 @CMAKE_SMPI_COMMAND@
9
10 SIMGRID_VERSION="@SIMGRID_VERSION_STRING@"
11 SIMGRID_GITHASH="@SIMGRID_GITHASH@"
12
13 DEFAULT_LOOPBACK_BANDWIDTH="498000000Bps"
14 DEFAULT_LOOPBACK_LATENCY="0.000004s"
15 DEFAULT_NETWORK_BANDWIDTH="$((26 * 1024 * 1024))Bps"
16 DEFAULT_NETWORK_LATENCY="0.000005s"
17 DEFAULT_NUMPROCS="4"
18 DEFAULT_SPEED="100flops"
19
20 LOOPBACK_BANDWIDTH="${DEFAULT_LOOPBACK_BANDWIDTH}"
21 LOOPBACK_LATENCY="${DEFAULT_LOOPBACK_LATENCY}"
22 NETWORK_BANDWIDTH="${DEFAULT_NETWORK_BANDWIDTH}"
23 NETWORK_LATENCY="${DEFAULT_NETWORK_LATENCY}"
24 SPEED="${DEFAULT_SPEED}"
25
26 PRIVATIZE="--cfg=smpi/privatization:@HAVE_PRIVATIZATION@"
27
28 SIMOPTS="--cfg=surf/precision:1e-9 --cfg=network/model:SMPI"
29
30 #usage to print the way this script should be called
31 usage () {
32     cat <<EOF
33 Usage: $0 [OPTIONS] -platform <xmldesc> -hostfile <hostfile> program [program-options]
34 Options:
35   -keep-temps                # don't remove the generated files after execution
36   -wrapper <command>         # use command to run the program (e.g. "valgrind" or "gdb --args")
37   -map                       # display the machine on which each process rank is mapped
38   -np <numprocs>             # use that amount of processes from the hostfile.
39                              # By default, all processes of the hostfile are used.
40   -no-privatize              # Disable the globals privatization, that is activated by default
41   -trace-ti                  # activate time independant tracing (for replay, default in smpi_simgrid.txt)
42   -trace                     # activate tracing (Paje, default in smpi_simgrid.trace)
43   -trace-comment <comment>   # put a comment on the top of the trace file
44   -trace-comment-file <file> # put file contents on the top of the trace file as comment
45   -trace-grouped             # group MPI processes by location
46   -trace-resource            # trace resource utilization
47   -trace-viva                # generate configuration for Viva's GraphView
48   -trace-file <tracefile>    # name of the tracefile (simgrid_smpi.trace)
49   -ext <value>               # additional parameter (reserved)
50
51   -version                   # Displays the SimGrid version (human readable)
52   -git-version               # Displays the git hash of SimGrid
53
54 or (deprecated usage):
55   $0 [-keep-temps] [-np <numprocs>] [-bandwidth <bytes/sec>] [-latency <secs>] program [program-options]
56
57 EOF
58 }
59
60 #check if we have at least one parameter
61 if [ $# -eq 0 ]
62 then
63     usage
64     exit
65 fi
66
67 EXTOPT=""
68 WRAPPER=""
69 HOSTFILE=""
70 HOSTFILETMP=0
71 MAPOPT=0
72 REPLAY=0
73
74 unset pid
75
76 trapped_signals="HUP INT QUIT ILL ABRT SEGV FPE ALRM TERM USR1 USR2 BUS"
77
78 die () {
79     printf '[%s] ** error: %s. Aborting.\n' "$(basename $0)" "$*" >&2
80     exit 1
81 }
82
83 smpirun_cleanup()
84 {
85   if [ -z "${KEEP}" ] ; then
86       if [ -z "${PLATFORM}" -a -n "$PLATFORMTMP" ]; then
87         rm -f ${PLATFORMTMP}
88         PLATFORMTMP=""
89       fi
90       if [ ${HOSTFILETMP} = 1 -a -n "$HOSTFILE" ] ; then
91           rm -f ${HOSTFILE}
92           HOSTFILE=""
93       fi
94       if [ ${UNROLLEDHOSTFILETMP} = 1 -a -n "$UNROLLEDHOSTFILE" ] ; then
95           rm -f ${UNROLLEDHOSTFILE}
96           UNROLLEDHOSTFILE=""
97       fi
98       if [ -n ${APPLICATIONTMP} ]; then
99         rm -f ${APPLICATIONTMP}
100         APPLICATIONTMP=""
101       fi
102   fi
103 }
104
105 smpirun_trap() {
106   local sig
107   sig="$1"
108
109   # Cleanup and kill the child process:
110   smpirun_cleanup
111   if ! [ -z "$pid" ]; then
112     kill -TERM $pid
113   fi
114   unset pid
115
116   # Raise the same signal again (remove the traps first):
117   trap - $trapped_signals
118   kill -$sig $$
119
120   # This should never happen:
121   kill -ABRT $$
122   kill -TERM $$
123 }
124
125 for s in $trapped_signals; do
126   trap "smpirun_trap $s" $s
127 done
128
129 while true; do
130     case "$1" in
131         "-np" | "-n")
132             NUMPROCS="$2"
133             shift 2
134             ;;
135         "-bandwidth")
136             NETWORK_BANDWIDTH="$2"
137             shift 2
138             ;;
139         "-latency")
140             NETWORK_LATENCY="$2"
141             shift 2
142             ;;
143         "-platform")
144             PLATFORM="$2"
145             if [ ! -f "${PLATFORM}" ]; then
146                 die "the file '${PLATFORM}' does not exist"
147             fi
148             shift 2
149             ;;
150         "-hostfile" | "-machinefile")
151             HOSTFILE="$2"
152             if [ ! -f "${HOSTFILE}" ]; then
153                 die "the file '${HOSTFILE}' does not exist"
154             fi
155             shift 2
156             ;;
157         "-ext")
158             EXTOPT="$2"
159             shift 2
160             ;;
161         "-no-privatize")
162             PRIVATIZE=""
163             shift 1
164             ;;
165         "-map")
166             MAPOPT=1
167             shift 1
168             ;;
169         "-trace")
170             TRACE_ACTIVE="true"
171             shift 1
172             ;;
173         "-trace-ti")
174             TRACE_ACTIVE="true"
175             TRACE_TI_ACTIVE="true"
176             shift 1
177             ;;
178         "-trace-comment")
179             TRACE_COMMENT="$2"
180             shift 2
181             ;;
182         "-trace-comment-file")
183             TRACE_COMMENT_FILE="$2"
184             shift 2
185             ;;
186         "-trace-file")
187             TRACE_FILENAME="$2"
188             shift 2
189             ;;
190         "-trace-grouped")
191             TRACE_GROUPED="true"
192             shift 1
193             ;;
194         "-trace-resource")
195             TRACE_RESOURCE="true"
196             shift 1
197             ;;
198         "-trace-viva")
199             TRACE_VIVA="true"
200             shift 1
201             ;;
202         "-keep-temps")
203             KEEP="true"
204             SIMOPTS="$SIMOPTS --cfg=smpi/keep-temps:yes"
205             shift 1
206             ;;
207         "-wrapper")
208             WRAPPER="$2"
209             shift 2
210             ;;
211         "-help" | "--help" | "-h")
212             usage
213             exit 0
214             ;;
215         "-version" | "--version" | "-v")
216             printf '%b\n' "$SIMGRID_VERSION"
217             exit 0
218             ;;
219         "-git-version" | "--git-version")
220             printf '%b\n' "$SIMGRID_GITHASH"
221             exit 0
222             ;;
223         "--cfg="*|"--log="*)
224             for OPT in ${1#*=}
225             do
226                 SIMOPTS="$SIMOPTS ${1%%=*}=$OPT"
227             done
228             shift 1
229             ;;
230         "-foreground")
231             # Nothing to do, compatibility.
232             shift 1
233             ;;
234         *)
235             break
236             ;;
237     esac
238 done
239
240 # check if we still have at least one parameter beyond options
241 if [ $# -eq 0 ]
242 then
243     echo "Error: no program to execute!"
244     usage
245     exit
246 fi
247
248 EXEC="$1"
249 shift
250
251 # steel --cfg and --logs options
252 while [ $# -gt 0 ]; do
253     case "$1" in
254         "--cfg="*|"--log="*)
255             for OPT in ${1#*=}
256             do
257                 SIMOPTS="$SIMOPTS ${1%%=*}=$OPT"
258             done
259             shift 1
260             ;;
261         *)
262             PROC_ARGS="${PROC_ARGS:+$PROC_ARGS }$1"
263             shift      
264             ;;
265     esac
266 done
267
268 if [ -z "${HOSTFILE}" ] && [ -z "${PLATFORM}" ] ; then
269     echo "No hostfile nor platform specified."
270     usage
271     exit 1
272 fi
273
274 if [ -z "${HOSTFILE}" ] ; then
275     HOSTFILETMP=1
276     HOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
277     perl -ne 'print "$1\n" if /.*<host.*?id="(.*?)".*?\/>.*/' ${PLATFORM} > ${HOSTFILE}
278     perl -ne 'if (/.*<cluster.*?prefix="(.*?)".*?radical="(.*?)".*?suffix="(.*?)".*/) { 
279                 my ($pre,$rad,$post)=($1,$2,$3); 
280                 for my $elm (split(",",$rad)) { 
281                   if ($elm=~/^([^-]*?)-([^-]*)$/) { 
282                      for (my $i=$1; $i<=$2;$i++) { 
283                         print "$pre$i$post\n"; 
284                      }
285                   } else {
286                      print "$pre$elm$post\n";
287                   }
288                 }
289               } elsif (/<cluster/) {
290             die ("Unparsable cluster tag. smpirun uses a primitive regular expression to parse cluster tags. Either provide a hostfile yourself or give the attributes prefix, radical and suffix IN THAT ORDER and ON THE SAME LINE as the opening tag (<cluster)");
291               }' ${PLATFORM} >> ${HOSTFILE}
292 fi
293 UNROLLEDHOSTFILETMP=0
294
295 #parse if our lines are terminated by :num_process
296 multiple_processes=$(grep -c ":" $HOSTFILE)
297 if [ "${multiple_processes}" -gt 0 ] ; then
298     UNROLLEDHOSTFILETMP=1
299     UNROLLEDHOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
300     perl -ne ' do{ for ( 1 .. $2 ) { print "$1\n" } } if /(.*?):(\d+).*/'  ${HOSTFILE}  > ${UNROLLEDHOSTFILE}
301     if [ ${HOSTFILETMP} = 1 ] ; then
302         rm ${HOSTFILE}
303         HOSTFILETMP=0
304     fi
305     HOSTFILE=$UNROLLEDHOSTFILE
306 fi
307
308 # Don't use wc -l to compute it to avoid issues with trailing \n at EOF
309 hostfile_procs=$(grep -c "[a-zA-Z0-9]" $HOSTFILE)
310 if [ ${hostfile_procs} = 0 ] ; then
311     die "the hostfile '${HOSTFILE}' is empty"
312 fi
313
314 if [ -z "${NUMPROCS}" ] ; then
315     # Use the amount of processes in the hostfile as default value for the -np parameter
316     NUMPROCS=$hostfile_procs
317 fi
318
319 if [ ${NUMPROCS} -gt ${hostfile_procs} ] ; then
320     echo "You requested to use ${NUMPROCS} ranks, but there is only ${hostfile_procs} processes in your hostfile..." >&2
321 fi
322
323 ##-------------------------------- DEFAULT or SPECIFIED PLATFORM --------------------------------------
324 if [ -z "${PLATFORM}" ]; then
325     PLATFORMTMP="$(mktemp smpitmp-platfXXXXXX)"
326
327     cat > ${PLATFORMTMP} <<PLATFORMHEAD
328 <?xml version='1.0'?>
329 <!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid/simgrid.dtd">
330 <platform version="4.1">
331 <zone id="AS0" routing="Full">
332 PLATFORMHEAD
333
334     i=${NUMPROCS}
335     while [ $i -gt 0 ]; do
336         echo "  <host id=\"host$i\" speed=\"${SPEED}\"/>" >> ${PLATFORMTMP}
337         echo "  <link id=\"loop$i\" bandwidth=\"${LOOPBACK_BANDWIDTH}\" latency=\"${LOOPBACK_LATENCY}\"/>" >> ${PLATFORMTMP}
338         echo "  <link id=\"link$i\" bandwidth=\"${NETWORK_BANDWIDTH}\" latency=\"${NETWORK_LATENCY}\"/>" >> ${PLATFORMTMP}
339         i=$((i - 1))
340     done
341
342     i=${NUMPROCS}
343     while [ $i -gt 0 ]; do
344         j=${NUMPROCS}
345         while [ $j -gt 0 ]; do
346             if [ $i -eq $j ]; then
347                 echo "  <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"loop$i\"/></route>" >> ${PLATFORMTMP}
348             else
349                 echo "  <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"link$i\"/><link_ctn id=\"link$j\"/></route>" >> ${PLATFORMTMP}
350             fi
351             j=$((j - 1))
352         done
353         i=$((i - 1))
354     done
355
356     cat >> ${PLATFORMTMP} <<PLATFORMFOOT
357 </zone>
358 </platform>
359 PLATFORMFOOT
360
361 else
362     PLATFORMTMP=${PLATFORM}
363 fi
364 ##-------------------------------- end DEFAULT or SPECIFIED PLATFORM --------------------------------------
365 ##-------------------------------- DEFAULT APPLICATION --------------------------------------
366 APPLICATIONTMP="$(mktemp smpitmp-appXXXXXX)"
367 #APPLICATIONTMP="app.xml"
368
369 cat > ${APPLICATIONTMP} <<APPLICATIONHEAD
370 <?xml version='1.0'?>
371 <!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid/simgrid.dtd">
372 <platform version="4.1">
373 APPLICATIONHEAD
374
375 ##---- cache hostnames of hostfile---------------
376 if [ -n "${HOSTFILE}" ] && [ -f ${HOSTFILE} ]; then
377     hostnames=$(cat ${HOSTFILE} | tr '\n\r' '  ')
378 fi
379
380 if [ "${EXTOPT}" = "smpi_replay" ]; then
381     APP_TRACES=$PROC_ARGS
382     if [ -n "${APP_TRACES}" ] && [ -f "${APP_TRACES}" ]; then
383         hosttraces=$(cat ${APP_TRACES} | tr '\n\r' '  ' )
384         NUMTRACES=$(cat ${APP_TRACES} | wc -l)
385         REPLAY=1
386     else
387         printf "File not found: %s\n" "${APP_TRACES:-\${APP_TRACES\}}" >&2
388         exit 1
389     fi
390 fi
391
392 ##----------------------------------------------------------
393 ##  generate application.xml with hostnames from hostfile:
394 ##  the name of host_i (1<=i<=p, where -np p) is the line i in hostfile (where -hostfile hostfile), or "host$i" if 
395 ##  hostfile has less than i lines.
396 ##----------------------------------------------------------
397
398 HAVE_SEQ="$(which seq 2>/dev/null)"
399
400 if [ -n "${HAVE_SEQ}" ]; then
401     SEQ=$(${HAVE_SEQ} 0 $(( NUMPROCS - 1)))
402 else
403     cnt=0
404     while [ $cnt -lt ${NUMPROCS} ] ; do
405         SEQ="$SEQ $cnt"
406         cnt=$((cnt + 1));
407     done
408 fi
409
410 set -- $hostnames
411
412 ##---- generate <actor> tags------------------------------
413 #prepare arguments at once
414 for ARG in $PROC_ARGS; do
415   XML_ARGS="${XML_ARGS}""<argument value=\"${ARG}\"/>
416 "
417 done
418
419 for i in ${SEQ}
420 do
421     j=$(( i % hostfile_procs + 1 ))
422     host=$(eval "echo \${$j}")
423
424     ##---- optional display of ranks to actor mapping
425     if [ ${MAPOPT} = 1 ]; then
426       echo "[rank $i] -> $host"
427     fi
428
429     echo "  <actor host=\"${host}\" function=\"$i\"> <!-- function name used only for logging -->
430     <argument value=\"smpirun\"/> <!-- instance -->
431     <argument value=\"$i\"/> <!-- rank -->" >> ${APPLICATIONTMP}
432     if [ ${REPLAY} = 1 ]; then
433         if  [ ${NUMTRACES} -gt 1 ]; then
434             echo "    <argument value=\"$(echo $hosttraces|cut -d' ' -f$j)\"/>" >> ${APPLICATIONTMP}
435         else
436             echo "    <argument value=\"$(echo $hosttraces|cut -d' ' -f1)\"/>" >> ${APPLICATIONTMP}
437         fi
438     else 
439     echo ${XML_ARGS} >> ${APPLICATIONTMP}
440     fi
441     echo "  </actor>" >> ${APPLICATIONTMP}
442 done
443
444 cat >> ${APPLICATIONTMP} <<APPLICATIONFOOT
445 </platform>
446 APPLICATIONFOOT
447 ##-------------------------------- end DEFAULT APPLICATION --------------------------------------
448 ##---------------------- SMPI TRACING OPTIONS ---------------------------------
449 if [ -n "${TRACE_ACTIVE}" ]; then
450     #define trace filename
451     if [ -n "${TRACE_TI_ACTIVE}" ]; then
452         if [ -z "${TRACE_FILENAME}" ]; then
453             TRACE_FILENAME="smpi_simgrid.txt"
454         fi
455         TRACEOPTIONS="--cfg=tracing:yes --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:yes --cfg=tracing/smpi/format:TI --cfg=tracing/smpi/computing:yes"
456     else
457         if [ -z "${TRACE_FILENAME}" ]; then
458             TRACE_FILENAME="smpi_simgrid.trace"
459         fi
460         TRACEOPTIONS="--cfg=tracing:yes --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:yes"
461     fi
462
463     if [ -n "${TRACE_COMMENT}" ]; then
464         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment:${TRACE_COMMENT}"
465     fi
466
467     if [ -n "${TRACE_COMMENT_FILE}" ]; then
468         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment-file:${TRACE_COMMENT_FILE}"
469     fi
470
471     if [ -n "${TRACE_GROUPED}" ]; then
472         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/smpi/group:yes"
473     fi
474
475     if [ -n "${TRACE_RESOURCE}" ]; then
476         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/categorized:yes --cfg=tracing/uncategorized:yes"
477     fi
478
479     if [ -n "${TRACE_VIVA}" ]; then
480         TRACEOPTIONS="${TRACEOPTIONS} --cfg=viva/categorized:smpi_cat.plist --cfg=viva/uncategorized:smpi_uncat.plist"
481     fi
482 fi
483 ##---------------------- end SMPI TRACING OPTIONS ---------------------------------
484
485 export SMPI_GLOBAL_SIZE=${NUMPROCS}
486 if [ -n "${KEEP}" ] ; then
487     echo ${EXEC} ${PRIVATIZE} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
488     if [ ${HOSTFILETMP} = 1 ] ; then
489         echo "Generated hostfile ${HOSTFILE} kept."
490     fi
491     if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
492         echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} kept." 
493     fi
494 fi
495
496 # Execute the process
497 #
498 # The shell still need to be alive for the duration in order to do some cleanup after the process.
499 #
500 # We are going through great lengths in order to both keep stdin and be able to handle signals:
501 #
502 # * The job is launched in the background in order to be able to handle signals.
503 #
504 # * The FD 3 is used to temporarily store FD 1. This is because the shell connects FD 1 to /dev/null when the command
505 #   is launched in the background: this can be overriden in bash but not in standard bourne shell.
506 exec 3<&0
507 ${WRAPPER} "@SMPIMAIN@" ${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP} <&3 3>&- &
508 pid=$!
509 exec 3>&-
510 wait $pid
511 status=$?
512 pid=""
513
514 # Keep temporary files on failures to help debugging
515 #
516 if [ ${status} -ne 0 ] ; then
517     if [ -z "${KEEP}" ]; then
518         echo ${EXEC} ${PRIVATIZE} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
519         if [ ${HOSTFILETMP} = 1 ] ; then
520             echo "Generated hostfile ${HOSTFILE} kept."
521         fi
522         if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
523             echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} kept."
524         fi
525     fi
526     echo "Execution failed with code ${status}."
527     KEEP=true
528 fi
529
530 smpirun_cleanup
531
532 exit $status